# 更新履歴

## 1.2.15 （2018-10-22）
- `ALLOK()` バリデート関数にて未選択のものがあるとエラーになっていた問題を修正しました。

## 1.2.14 （2018-10-22）
- 特定バージョンのPHP自体のバグが原因で、 `mb_convert_variables()` 関数が正常に実行できなかった問題に対応しました。

## 1.2.13 （2018-10-19）
- 設定ファイル `form_template` で設定したテンプレートの文字コードを `header()` にてContent-typeヘッダーに出力するように修正。（`<meta>` タグでの文字コード指定が効かないブラウザがあるための対応）

## 1.2.12 （2018-08-02）
- PHP7.2にて `count()` 関数のエラー挙動が変わったためにエラーになっていた問題を対応。

## 1.2.11 （2018-07-02）
- HTMLメールではない場合に文字化けしてしまう問題を修正

## 1.2.10 （2018-03-06）
- セキュリティオプション `X-Content-Type-Options` が１つ多く出力されていたので `X-Frame-Options: SAMEORIGIN` に修正。
- メールヘッダの文字コード`ISO-2022-JP`→`ISO-2022-JP-MS`にすることで、UTF-8じゃなくても機種依存文字も文字化けせずにメールできるように修正。
- PHPMailerバージョンアップ 5.2.23 → 6.0.3（kazaokiフォーク版）
- HTMLメール添付周りの不具合を調整（プレーンメール分の追加、文字化け対策）

## 1.2.9 （2017-12-15）
- 完了画面のGETリダイレクト時に303を返すように修正。
- メールテンプレートの改行コードが `LF` ではなく `CRLF` だった場合にPHPコードの末尾に自動改行が入らなかった問題を修正。
- メール設定の `is_utf8` を未指定（またはnullを指定）した場合、入力文字にUTF-8があれば自動的にutf8になるように修正。

## 1.2.8 （2017-12-11）
- バリデータ `email(1)` のエラーメッセージをより適切なものに修正。
- サンプルフォームの設定ファイルにセキュリティ設定が重複して存在していたのを修正。
- テンプレートタグの `file_preview_tag()` の出力が空の時に、未入力のHTMLタグがエスケープされてしまっていたので修正。

## 1.2.7 (2017-12-4)
- プロクシ内でも正しくグローバルIPをメール文章中に差し込めるように修正。
- 内部プログラムで細かいデバグ

## 1.2.6 (2017-12-4)
- security_headersを個別指定できるように修正。

## 1.2.5 (2017-11-29)
- フォーム送信中は `body` に `fk-sending` クラスが追加されるように改修。
- サブバリデートが `REQ()` が無いと、指定要素が空の時にエラーにならない問題を対応。

## 1.2.4 (2017-09-06)
- `validates()` にて、引数になにも要素が指定されない場合は、成功としてそのままコールバックにfalse(成功)を渡すように修正。
- `require` → `require_once` に変更
- jsfuncでajaxオブジェクトを返すことで、その処理が完了するのを待つように修正。
- disabled要素の除外を、Ajax返却時以外に、フォーカス時点から除外するように調整。
- `validates()` の第二引数に関数を指定しないとエラーになっていた問題を修正。
- FK対象外のテキスト入力BOXで入力が消えてしまう問題を対処
- `elemnt()` メソッドに存在しない要素名を指定するとエラーになるのを回避するように修正。
- disabled要素のチェック箇所を調整
- 文字列のスプリッタを /\W+/ → /[\, ]+/ に変更。
- jsfunc周り調整など
- 単独バリデート呼び出し関数 `validates()` を用意。 `validate()` と違い、複数の要素を一変にチェック可能。
- disabledな要素はJS側でバリデート結果を反映しないように修正
- display:none で隠れたエラーがある場合submitできなかったので、隠れてるものは無視するように修正。
- 動的要素の追加と、独自JSチェッカを実装
- フックポイントの追加：`on_init_before()`, `on_init_after()`
- 動的に追加された要素に対して `data-fk-jsfunc` を実行可能に修正。
- ヘルパー関数 `\FK\error_tag()` と `\FK\marker_tag()` の実装。
- 入力BOXにフォーカスがあたった状態でEnterした際に、エラーでも遷移してしまっていた問題を修正。（入力中のBOXのみエラーの場合に発症）

## 1.2.3b (2017-04-24)
- 設定キー名変更 `ua_allow_regex` → `ua_deny_regex`

## 1.2.3 (2017-04-24)
- ブラウザのユーザーエージェントに指定文字が入っている場合は送信しない機能追加
- 入力データにマルチバイト文字が入っていない場合は送信しない機能追加
- 指定のIPの場合は送信しない機能追加
- 指定の秒数を待たないと同一IPから再度送信できない機能追加

## 1.2.2 (2017-04-11)
- inputテキスト要素以外をグループした際に挙動がおかしかったので `fk.js` 修正。
- `namespace FK;` を全体に導入・調整。

## 1.2.1 (2017-04-10)
- `core.php` 実行時にPHPバージョンをチェックする機能を追加。
- コピーライト文言の修正
- スクリプト冒頭にライセンス文言挿入
- 余計なディレクトリが含まれていたので整理
- `core.php` 内部で強制的に `display_errors` を `0` にしていたのを削除した。組み込み側が制御できるように。

## 1.2.0 (2017-03-31)
- 公開バージョン
